#define WINVER 0x0410
#include <windows.h>
 
#define _USE_MATH_DEFINES
#include <math.h>
 
#pragma comment(lib, "Winmm")
 
#define SAMPLE_RATE 44100
#define FREQUENCY 1000
#define BLOCK_SIZE 4000
 
#define MAX_NUM 0x7fff  //  short
 
using namespace std;
 
LRESULT CALLBACK WinProc(HWND, UINT, WPARAM, LPARAM);
 
CHAR className[] = "main";
 
HWAVEOUT wave;
WAVEHDR hdr1, hdr2;
int iHdr = 1;
int time = 0;
short data1[BLOCK_SIZE], data2[BLOCK_SIZE];
 
void CALLBACK waveOutCallBack(HWAVEOUT hWave, UINT msg, DWORD inst, DWORD param1, DWORD param2) {
    if (msg == WOM_DONE) {
        if (iHdr == 1) {
            for (int t = 0; t < BLOCK_SIZE; t++) {
                data1[t] = sin((time + t) * 2 * M_PI * FREQUENCY / SAMPLE_RATE) * MAX_NUM; // 2*PI
            }
            waveOutWrite(wave, &hdr1, sizeof(WAVEHDR));
            iHdr = 2;
        }
        else {
            for (int t = 0; t < BLOCK_SIZE; t++) {
                data2[t] = sin((time + t) * 2 * M_PI * FREQUENCY / SAMPLE_RATE) * MAX_NUM; // 2*PI
            }
            waveOutWrite(wave, &hdr2, sizeof(WAVEHDR));
            iHdr = 1;
        }
        time += BLOCK_SIZE;
    }
}
 
int main() {
    WAVEFORMATEX wForm;
    wForm.wFormatTag = WAVE_FORMAT_PCM;
    wForm.nChannels = 1;
    wForm.nSamplesPerSec = SAMPLE_RATE;
    wForm.wBitsPerSample = 16;
    wForm.nBlockAlign = wForm.nChannels * wForm.wBitsPerSample / 8;
    wForm.nAvgBytesPerSec = wForm.nSamplesPerSec * wForm.nBlockAlign;
    wForm.cbSize = NULL;
    waveOutOpen(&wave, WAVE_MAPPER, &wForm, (DWORD_PTR)waveOutCallBack, 0, CALLBACK_FUNCTION);
 
    hdr1.lpData = (char*)data1;
    hdr1.dwBufferLength = BLOCK_SIZE * sizeof(short); //         
    //hdr1.dwFlags = 0;
 
    hdr2.lpData = (char*)data2;
    hdr2.dwBufferLength = BLOCK_SIZE * sizeof(short); //         
    //hdr2.dwFlags = 0;
 
    waveOutPrepareHeader(wave, &hdr1, sizeof(WAVEHDR));
    waveOutPrepareHeader(wave, &hdr2, sizeof(WAVEHDR));
 
    for (int t = 0; t < BLOCK_SIZE; t++) {
        data1[t] = sin(t * 2 * M_PI * FREQUENCY / SAMPLE_RATE) * MAX_NUM; // 2*PI
    }
    for (int t = 0; t < BLOCK_SIZE; t++) {
        data2[t] = sin((t + BLOCK_SIZE) * 2 * M_PI * FREQUENCY / SAMPLE_RATE) * MAX_NUM; // 2*PI
    }
 
    iHdr = 1;
    time += BLOCK_SIZE * 2;
    waveOutWrite(wave, &hdr1, sizeof(WAVEHDR));
    waveOutWrite(wave, &hdr2, sizeof(WAVEHDR));
    Sleep(4000);
 
    waveOutUnprepareHeader(wave, &hdr1, sizeof(WAVEHDR));
    waveOutUnprepareHeader(wave, &hdr2, sizeof(WAVEHDR));
    waveOutClose(wave);
}